﻿namespace ConfORM_Tests.Domain
{
	public class Item
	{
		public int Id { get; set; }

		public string Name { get; set; }

		public bool Equals(Item other)
		{
			if (ReferenceEquals(null, other)) return false;
			if (ReferenceEquals(this, other)) return true;
			return other.Id == Id;
		}

		public override bool Equals(object obj)
		{
			if (ReferenceEquals(null, obj)) return false;
			if (ReferenceEquals(this, obj)) return true;
			if (obj.GetType() != typeof (Item)) return false;
			return Equals((Item) obj);
		}

		public override int GetHashCode()
		{
			return Id;
		}

		public static bool operator ==(Item left, Item right)
		{
			return Equals(left, right);
		}

		public static bool operator !=(Item left, Item right)
		{
			return !Equals(left, right);
		}
	}
}
